#!/bin/sh
#
# Script to generate $C_FILE
#

ECHO=/usr/bin/printf

#MINUS_e=X`$ECHO -n -e`
#if [ $MINUS_e != "X" ] ; then
#	MINUS_e=""
#else
#	MINUS_e="-e"
#fi

#MINUS_E=X`$ECHO -n -E`
#if [ $MINUS_E != "X" ] ; then
#	MINUS_E=""
#else
#	MINUS_E="-E"
#fi


CUR_DIR=`pwd`
C_FILE="$CUR_DIR/modules_init.c"
H_FILE="$CUR_DIR/modules_init.h"

/usr/bin/printf "Scanning extension modules for entry points.\n"
/usr/bin/printf "This version of echo $ECHO supports $MINUS_e $MINUS_E.\n"


#start of the files which inturn removes any existing file
#
cat <<EOF  >$C_FILE
/*
 * $C_FILE
 * Auto generated by mk_modules_init.sh DO NOT EDIT THIS FILE
 */



#include "sysdep.h"
#include <stdlib.h>
#include <time.h>
#include <ctype.h>
#include <stdio.h>
#include "citadel.h"
#include "modules_init.h"
#include "sysdep_decls.h"


void LogPrintMessages(long err);
extern long DetailErrorFlags;



void initialise_modules (void)
{
    long filter;
    nSizErrmsg = 0;

    lprintf (CTDL_INFO, "New citadel module init proceedure.\n");
EOF


#start the header file
cat <<EOF > $H_FILE
/* 
 * $H_FILE
 * Auto generated by mk_modules_init.sh DO NOT EDIT THIS FILE
 */


#ifndef MODULES_INIT_H
#define MODULES_INIT_H
#include "ctdl_module.h"
extern size_t nSizErrmsg;
void initialise_modules (void);

EOF

for i in serv_*.c
do
	RES=X`grep CTDL_MODULE_INIT $i | cut -f2 -d\( | cut -f1 -d\)`
	if [ $RES != "X" ] ; then
		RES_OUT=`echo $RES | cut -b2-`
		/usr/bin/printf "Found entry point in file $i\n"
cat <<EOF  >> $C_FILE
	lprintf (CTDL_INFO, "%%s\n", CTDL_INIT_CALL($RES_OUT));

EOF
cat <<EOF >>$H_FILE
CTDL_MODULE_INIT($RES_OUT);
EOF
	fi
done


if [ -d "modules" ] ; then
	cd modules
	for j in *
	do
		if [ -d $j ] ; then
			cd $j
			for k in *.c
			do
				if [ -f "$k" ] ; then
					RES=X`grep CTDL_MODULE_INIT $k | cut -f2 -d\( | cut -f1 -d\)`
					if [ $RES != "X" ] ; then
						RES_OUT=`echo $RES | cut -b2-`
						/usr/bin/printf "Found entry point in file modules/$j/$k\n"
cat <<EOF >> $C_FILE
	lprintf (CTDL_INFO, "%s\n", CTDL_INIT_CALL($RES_OUT));
EOF
cat <<EOF >> $H_FILE
	CTDL_MODULE_INIT($RES_OUT);
EOF
					fi
				fi
			done
			cd ..
		fi
	done
fi

cd $CUR_DIR

if [ -d "user_modules" ] ; then
	cd user_modules
	for j in *
	do
		if [ -d $j ] ; then
			cd $j
			for k in *.c
			do
				if [ -f "$k" ] ; then
					RES=X`grep CTDL_MODULE_INIT $k | cut -f2 -d\( | cut -f1 -d\)`
					if [ $RES != "X" ] ; then
						RES_OUT=`echo $RES | cut -b2-`
						/usr/bin/printf "Found entry point in file user_modules/$j/$k\n"
cat <<EOF >> $C_FILE
	lprintf (CTDL_INFO, "%s\n", CTDL_INIT_CALL($RES_OUT));
EOF
cat <<EOF >> $H_FILE
CTDL_MODULE_INIT($RES_OUT);
EOF
					fi
				fi
			done
			cd ..
		fi
	done
fi

cd $CUR_DIR

/usr/bin/printf "\n\n" >> $C_FILE
/usr/bin/printf "\tfor (filter = 1; filter != 0; filter = filter << 1)\n" >> $C_FILE
/usr/bin/printf "\t\tif ((filter & DetailErrorFlags) != 0)\n" >> $C_FILE
/usr/bin/printf "\t\t\tLogPrintMessages(filter);\n" >> $C_FILE
/usr/bin/printf "}\n" >> $C_FILE


/usr/bin/printf "\n#endif /* MODULES_INIT_H */\n" >> $H_FILE
